;NOTA:
;
; Create .EXE assembling with the command:
;
;                         nasm main.asm -o wnd_0000.exe
;

%include "winuser.inc"

EXE_start:

FileAlignment    equ 0x200
SectionAlignment equ 0x1000

ImageBase equ 0x400000

NumSections equ 4

%define round(n, r) (((n+(r-1))/r)*r)




bits 16
DOS_stub:
DOS_stub_start:
 DOS_stub.MZ_header      db     'MZ'          ;e_magic field


 DOS_stub.Padding        times  0x3A db 0     ;nothing in this DOS EXE


 DOS_stub.PE_header_ptr  dd     PE_header     ;e_lfanew field

DOS_stub_end:
DOS_stub_SZ equ (DOS_stub_end-DOS_stub_start)













PE_header:
PE_header_start:

  PE_header.Signature            db 'PE',0,0

  PE_header.Machine              dw 0x14C

  PE_header.NumberOfSections     dw NumSections

  PE_header.TimeDateStamp        dd 0x3DF33453

  PE_header.PointerToSymbolTable dd 0

  PE_header.NumberOfSymbols      dd 0

  PE_header.SizeOfOptionalHeader dw Optional_Header_SZ

  PE_header.Characteristics      dw 0x010F

PE_header_end:
PE_header_SZ equ (PE_header_end-PE_header_start)






Optional_Header:
Optional_Header_start:

  Optional_Header.Magic                   dw 0x10B
  Optional_Header.MajorLinkerVersion      db 5
  Optional_Header.MinorLinkerVersion      db 0xC
  Optional_Header.SizeOfCode              dd round(_Code_SZ,FileAlignment)
  Optional_Header.SizeOfInitializedData   dd round(_Data_SZ,FileAlignment)
  Optional_Header.SizeOfUninitializedData dd 0
  Optional_Header.AddressOfEntryPoint     dd round(_Code,SectionAlignment)
  Optional_Header.BaseOfCode              dd round(_Code,SectionAlignment)
  Optional_Header.BaseOfData              dd round(_Code_SZ,SectionAlignment)+round(_Data,SectionAlignment) ;round(_Data,SectionAlignment)
  Optional_Header.ImageBase               dd ImageBase
  Optional_Header.SectionAlignment        dd SectionAlignment
  Optional_Header.FileAlignment           dd FileAlignment
  Optional_Header.MajorOSVersion          dw 4
  Optional_Header.MinorOSVersion          dw 0
  Optional_Header.MajorImageVersion       dw 0
  Optional_Header.MinorImageVersion       dw 0
  Optional_Header.MajorSubsystemVersion   dw 4
  Optional_Header.MinorSubsystemVersion   dw 0
  Optional_Header.Win32VersionValue       dd 0
  Optional_Header.SizeOfImage             dd round(Headers_SZ,SectionAlignment)+round(_Code_SZ,SectionAlignment)+round(_data_SZ,SectionAlignment)+round(_idata_SZ,SectionAlignment)+round(_ResourceTable_SZ,SectionAlignment)
  Optional_Header.SizeOfHeaders           dd round(Headers_SZ,FileAlignment)
  Optional_Header.Checksum                dd 0
  Optional_Header.Subsystem               dw 2
  Optional_Header.DllCharacteristics      dw 0
  Optional_Header.SizeOfStackReserve      dd 0x1000
  Optional_Header.SizeOfStackCommit       dd 0x1000
  Optional_Header.SizeOfHeapReserve       dd 0x1000
  Optional_Header.SizeOfHeapCommit        dd 0x1000
  Optional_Header.LoaderFlags             dd 0
  Optional_Header.NumberOfRvaAndSizes     dd 16
    Optional_Header.ExportTable.VirtualAddress           dd 0
    Optional_Header.ExportTable.Size                     dd 0

    Optional_Header.ImportTable.VirtualAddress           dd _.idata_RVA
    Optional_Header.ImportTable.Size                     dd _idata_SZ

    Optional_Header.ResourceTable.VirtualAddress         dd _.rsrc_RVA
    Optional_Header.ResourceTable.Size                   dd _ResourceTable_SZ

    Optional_Header.ExceptionTable.VirtualAddress        dd 0
    Optional_Header.ExceptionTable.Size                  dd 0

    Optional_Header.CertificateTable.VirtualAddress      dd 0
    Optional_Header.CertificateTable.Size                dd 0

    Optional_Header.BaseRelocationTable.VirtualAddress   dd 0
    Optional_Header.BaseRelocationTable.Size             dd 0

    Optional_Header.Debug.VirtualAddress                 dd 0
    Optional_Header.Debug.Size                           dd 0

    Optional_Header.Architecture.VirtualAddress          dd 0
    Optional_Header.Architecture.Size                    dd 0

    Optional_Header.GlobalPtr.VirtualAddress             dd 0
    Optional_Header.GlobalPtr.Size                       dd 0

    Optional_Header.TLSTable.VirtualAddress              dd 0
    Optional_Header.TLSTable.Size                        dd 0

    Optional_Header.LoadConfigTable.VirtualAddress       dd 0
    Optional_Header.LoadConfigTable.Size                 dd 0

    Optional_Header.BoundImport.VirtualAddress           dd 0
    Optional_Header.BoundImport.Size                     dd 0

    Optional_Header.IAT.VirtualAddress                   dd 0
    Optional_Header.IAT.Size                             dd 0

    Optional_Header.DelayImportDescriptor.VirtualAddress dd 0
    Optional_Header.DelayImportDescriptor.Size           dd 0

    Optional_Header.CLRRuntimeHeader.VirtualAddress      dd 0
    Optional_Header.CLRRuntimeHeader.Size                dd 0

    Optional_Header.Reserved.VirtualAddress              dd 0
    Optional_Header.Reserved.Size                        dd 0


Optional_Header_end:
Optional_Header_SZ equ (Optional_Header_end-Optional_Header_start)



SectHeaders_start:
%include "sectheaders/hdr.asm"
SectHeaders_SZ equ $-SectHeaders_start

align FileAlignment,db 0


Headers_SZ equ (DOS_stub_SZ+PE_header_SZ+Optional_Header_SZ+SectHeaders_SZ)





_Code equ $-$$
__Code:

;NOTE: Uncomment only one of the following sample programs
;      via the commented %include directives.
;
;      If you uncomment more than one, you will execute more
;      than one example. Don't do it unless that's what you want
;      and you know exactly what you are doing.



;Sample message box with bad and/or NULL pointers to strings:
;;
; %include "_text/snippets/error.asm"


;Sample "Hello World" ANSI message box:
;;
 %include "_text/snippets/helloansi.asm"


_Code_VSZ equ $-__Code
align FileAlignment,db 0
_Code_SZ equ $-__Code






_Data equ $-$$
__Data:


_data equ $-$$
__data:



_data_:

;NOTE: Uncomment only one of the following sample program
;      data contents via the commented %include directives.
;
;      If you uncomment more than one, you will include the contents
;      of the data section for more than one example. Don't do it
;      unless that's what you want and you know exactly what you are doing.


;Sample "Hello World" ANSI message box strings:
;;
 %include "_data/snippets/helloansi.asm"




_data_VSZ equ $-__data
align FileAlignment,db 0
_data_SZ equ $-__data





_idata equ $-$$
__idata:

%include "_idata/idata.asm"
_idata_VSZ equ $-__idata
align FileAlignment,db 0
_idata_SZ equ $-__idata




_ResourceTable equ $-$$
__ResourceTable:

%include "_rsrc/rsrc.asm"


_ResourceTable_VSZ equ $-__ResourceTable
align FileAlignment,db 0
_ResourceTable_SZ equ $-__ResourceTable




_Data_end:
_Data_SZ equ _Data_end-__Data



EXE_end:
EXE_SZ equ (EXE_end-EXE_start)
